# flcheck --
#
# This file implements package flcheck, a fusion logic modelchecker 
# using the CUDD BDD package
#
# Copyright (C) 2009, 2010  Antonio Cau

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

###

proc test_formula {} {
    set x "not {[equiv A B]}"
    set y "not A"
    set z "[equiv $y B]"
    return [equiv $z $x]
}

proc test_formula_1 {} {
    set x "[fin A]"
    set y "< [finite_e] > { [and [empty] A ] }"
    return [equiv $x $y]
}

proc test_formula_2 {} {
    set x "not { [fin A] }"
    set y "not A"
    set z "< [finite_e] > { [and [empty] $y ] }"
    return [equiv $x $z]
}

proc test_formula_3 {} {
    set x "<test { A }> { true }"
    return [equiv $x A]
}

proc test_paper {} {
    return "<chopstar{step{A}}>{B or C} or <step{A};test{B}>{D}"
}

#proc test_equiv {} {
#    set a "[equiv X true]"
#    set b "[equiv Y [false]]"
#    set c "[strong_p_rule_s_1_0 X AP]"
#    set d "[strong_p_rule_s_1_0 Y AN]"
#    set e1 "not AN"
#    set e "[strong_p_rule_s_1_0 AD [and AP $e1]]"
#    set z [always [l_and [list $a $b $c $d $e]]]
#    return $z
#}


proc test_for {} {
    return "[equiv [and {P or Q} P] P]" 
}